Name:      openpbs
Version:   2.3pl16
Release:   1cplant
License:   Free to use, but restricted
Summary:   OpenPBS, a job queueing system
Group:     Applications/System
URL:       http://www.openpbs.org/
Vendor:    Veridian Systems
Packager:  David Groep <davidg@nikhef.nl>
Source0:   OpenPBS_2_3_16.tar.gz
Source1:   pbs
Patch1:    openpbs-buildroot.patch
Patch2:    cplantFRpatch
BuildRoot: /tmp/openpbs-rpm
requires: /usr/sbin/sendmail

%description
OpenPBS, the Portable Batch System, is designed for running jobs on one or
more execution hosts, which can be running a variety of operating systems.
With CPlant Fault Recovery patches.

%package exechost
Summary: OpenPBS exechost (MOM daemon)
Group: Applications/System
requires: openssh
buildrequires: openssh
%description exechost
The OpenPBS MOM daemon and clients, which runs on each machine that will 
run PBS jobs.

%prep
%setup -n OpenPBS_2_3_16
# Apply official PBS patches (if any)
#for pl in 13 14 15; do
#   ${RPM_SOURCE_DIR}/pbs_patch.sh < ${RPM_SOURCE_DIR}/patch_OpenPBS_2.3.$pl
#done

# openpbs-buildroot.patch (fixes "make install" so that it installs into
# our buildroot)
%patch1 -p1

# CPlant FR patches
%patch2 -p1

# Make sure configure is synced with configure.in
autoconf

%build
CFLAGS="-DCPLANT_NONBLOCKING_CONNECTIONS=1 -DCPLANT_SERVICE_NODE=1"
export CFLAGS

./configure --with-scp=/usr/bin/scp --prefix=/usr/pbs --enable-gui --set-default_server=localhost
make

%install
PBS_ROOT=${RPM_BUILD_ROOT}/usr/spool/PBS/
RCDIR=${RPM_BUILD_ROOT}/etc/rc.d/

# Standard OpenPBS install (subdir doc/ is seemingly not installed by default)
make DESTDIR=${RPM_BUILD_ROOT} install
cd doc
make DESTDIR=${RPM_BUILD_ROOT} install

# Make server_priv world-executable so that non-root users can get in
# to look at the accounting files
chmod 0751 ${PBS_ROOT}/server_priv

# You probably want to install a more complete MOM configuration here!
# This is also an ideal place to copy custom server/scheduler configuration
# files from ${RPM_SOURCE_DIR} to ${PBS_ROOT}
touch ${PBS_ROOT}/mom_priv/config
echo "localhost" > ${PBS_ROOT}/server_name

# Install init scripts for server, scheduler and MOM; we make the
# symlinks manually as chkconfig apparently doesn't understand chroot
install -d ${RCDIR}
for init in init.d rc0.d rc1.d rc2.d rc3.d rc4.d rc5.d rc6.d; do
  install -d ${RCDIR}/$init
done
cp ${RPM_SOURCE_DIR}/pbs ${RCDIR}/init.d

# Build tcl indices for xpbsmon and xpbs (have to do this here as it uses
# absolute paths, and gets confused by a buildroot)
XPBSMON_LIB=${RPM_BUILD_ROOT}/usr/pbs/lib/xpbsmon
cd ${XPBSMON_LIB} && ./buildindex ${XPBSMON_LIB} && chmod 644 tclIndex
XPBS_LIB=${RPM_BUILD_ROOT}/usr/pbs/lib/xpbs
cd ${XPBS_LIB} && ./buildindex ${XPBS_LIB} && chmod 644 tclIndex

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
/usr/spool/PBS
/usr/pbs
/etc/rc.d/init.d/pbs

%files exechost
%defattr(-,root,root)
/usr/pbs/sbin/pbs_mom
/usr/pbs/sbin/pbs_rcp
/usr/pbs/sbin/pbs_demux
/usr/pbs/sbin/pbs_iff
/usr/pbs/bin
%dir /usr/spool/PBS/aux
%dir /usr/spool/PBS/checkpoint
%dir /usr/spool/PBS/spool
%dir /usr/spool/PBS/undelivered
%dir /usr/spool/PBS/mom_logs
%dir /usr/spool/PBS/mom_priv
%dir /usr/spool/PBS/mom_priv/jobs
%config /usr/spool/PBS/mom_priv/config
/usr/spool/PBS/server_name
/etc/rc.d/init.d/pbs


%changelog
